﻿Dim ImageObj, PageObj, RepositoryFrom, RepositoryTo
Dim win, control

Set RepositoryFrom = CreateObject ("Mercury.ObjectRepositoryUtil")
Set win = nothing
Set control = nothing

'Set RepositoryTo = CreateObject ("Mercury.ObjectRepositoryUtil")
RepositoryFrom.Load "T:\QTP_Tests\Data\Default.tsr"
'RepositoryTo.Load "T:\QTP_Tests\Data\Default.tsr"

'#############################################################################
'# The function enumerates recursively all the Test Objects under a given root.                            #
'# For each Test Object it prompts a message box with its logical name, properties names and    #
'# values.                                                                                                                                           #
'#############################################################################
Function EnumarateAllChildrenProperties(Root, ByVal tab)
 	Dim TOCollection, TestObject, PropertiesCollection, Property, Msg
	Set TOCollection = RepositoryFrom.GetChildren(Root)
	For i = 0 To TOCollection.Count-1
	    	Set TestObject = TOCollection.Item(i)
	    	Msg = tab & RepositoryFrom.GetLogicalName(TestObject) & vbNewLine
	    	Set PropertiesCollection = TestObject.GetTOProperties()
	   
    		For n = 0 To PropertiesCollection.Count-1
	     		Set Property = PropertiesCollection.Item(n)
	    		Msg = Msg & tab & Property.Name & "-" & Property.Value & vbNewLine
	    	Next
	    	'MsgBox Msg
			file_append "T:\QTP_Tests\Tools\OjectRepository.txt", Msg
	   	EnumarateAllChildrenProperties TestObject, tab&vbTab
	Next
End Function

'#############################################################################
'# The function enumerates recursively all the Test Objects under a given root.                            #
'# For each Test Object it prompts a message box with its logical name, properties names and    #
'# values.                                                                                                                                           #
'#############################################################################
Function GenerateObjectRepositoryList(ByRef Root)
 	Dim TOCollection, TestObject, PropertiesCollection, Property, Msg
	Set TOCollection = RepositoryFrom.GetChildren(Root)
	For i = 0 To TOCollection.Count-1
	    	Set TestObject = TOCollection.Item(i)
	    	Msg = RepositoryFrom.GetLogicalName(TestObject) 'vbNewLine
			file_append "T:\QTP_Tests\Data\OjectRepository.txt", Msg
	   	GenerateObjectRepositoryList TestObject
	Next
	
End Function

'#############################################################################
'# The function enumerates all the Test Objects under a given root.                                              #
'# For each Test Object it prompts a message box with its logical naze, properties names and     #
'# values.                                                                                                                                          #
'#############################################################################
Function EnumarateAllObjectsProperties(Root)
   Dim TOCollection, TestObject, PropertiesCollection, Property, Msg
	Set TOCollection = RepositoryFrom.GetAllObjects(Root)
	
	For i = 0 To TOCollection.Count-1
		Set TestObject = TOCollection.Item(i)
      Msg =  RepositoryFrom.GetLogicalName(TestObject) & vbNewLine
      Set PropertiesCollection = TestObject.GetTOProperties()
	   For n = 0 To PropertiesCollection.Count-1
	   	Set Property = PropertiesCollection.Item(n)
	   	Msg = Property.Name & "-" & Property.Value & vbNewLine
	   Next
		MsgBox Msg
	Next
End Function

'#############################################################################
'# The function sets new logical name for all image Test Objects under a given root.                   #
'#############################################################################
Function RenameAllImages(Root)

 Dim TOCollection, TestObject, PropertiesCollection, Property
	
	Set TOCollection = RepositoryTo.GetAllObjectsByClass("Image")
	
	For i = 0 To TOCollection.Count-1
	    	Set TestObject = TOCollection.Item(i)
	    	RepositoryTo.RenameObject TestObject, "Image " & i
	    	RepositoryTo.UpdateObject Testobject
	Next
	
End Function

'#############################################################################
'# The function enumerates recursively all the Test Objects under a given root.                           # 
'# It looks for the Link Test Objects and Removes them from their parents.			        #
'#############################################################################
Function RemoveAllLinks(Root)
 	Dim TOCollection, TestObject, PropertiesCollection, Property
	
	Set TOCollection = RepositoryFrom.GetChildren(Root)
	
	For i = 0 To TOCollection.Count-1
	    	Set TestObject = TOCollection.Item(i)
	    	TOClass = TestObject.GetTOProperty("micclass")	 
	    
   		 If  TOClass = "Link" Then 
	     		RepositoryFrom.RemoveObject Root, TestObject
	    	End If 
		   
	   	EnumarateAllChildrenProperties TestObject
	Next

End Function

Public function utl_add_gui(parentObjName, objClass, objName, objProperties)
	Set RepositoryFrom = CreateObject ("Mercury.ObjectRepositoryUtil")	' Load the Object Repository in question
	RepositoryFrom.Load "T:\QTP_Tests\Data\Default.tsr"
	set parentObj = RepositoryFrom.GetObject(parentObjName)	'Get Parent Object of which we want to add the new Test Object under
   set newobj = CreateObject(objClass)	' Create a new Test Object ( A Stdbutton in this case ) and set the

	objPropertiesa = split(objProperties,"|")
	For i = 0 to ubound(objPropertiesa)
		propa = split (objPropertiesa(i),"=")			' properties for this object
		newobj.SetTOProperty propa(0),propa(1)  
	Next

	RepositoryFrom.AddObject newobj, ParentObj, "No"		' Add the new Test Object (StdButton) to the parent object

	RepositoryFrom.Save											' Save the changes and release the objects
	Set parentObj = nothing
	Set newobj = nothing
	Set RepositoryFrom = nothing 
End Function

'utl_add_gui "SwfWindow(""WLSTP"")", "Mercury.SwfButton", "btnSaveWiring", "swfname=m_buttonOK"
'"SwfWindow(""WLSTP"")
'Mercury.SwfButton
'(""btnSaveWiring")
'"swfname","m_buttonOK"


Function get_object_by_name(obj_name, ByRef obj_ref, ByRef Root)
 	Dim TOCollection,TestObject,i,cname
	Set TOCollection = RepositoryFrom.GetChildren(Root)
    For i = 0 To TOCollection.Count-1
	    	Set TestObject = TOCollection.Item(i)
	    	cname = RepositoryFrom.GetLogicalName(TestObject)
			If cname=obj_name Then
				Set obj_ref = TestObject
				Exit function
			End If
	   	get_object_by_name obj_name, obj_ref, TestObject
	Next
End Function

'--------------------------------------------------------------------------------------------------
'@Description Set value to different types of objects. Object type is recognized by its prefix
'@Documentation set value for <obj_name> to <val>
Public function set_value(obj_name, val)
	Dim otype
	otype = left(obj_name,3)
	set_value = cPASS
	get_object_by_name "txtConfirmationWAM",control,win
	
	Select Case otype
	Case "dat", "obj"
		SwfWindow(app_title).SwfObject(obj_name).Object.Value = val
	Case "txt"
		control.Text = val
		'SwfWindow(app_title).SwfEdit(obj_name).Object.Text = val
	Case "txe"
		SwfWindow(app_title).SwfEditor(obj_name).Object.Text = val
	Case   "cbo"
		select_combo obj_name, val
	Case "chk"
		SwfWindow(app_title).SwfObject(obj_name).Object.Checked = val
	Case "rad"
		SwfWindow(app_title).SwfRadioButton(obj_name).Object.Checked = val
	Case Else
        report_log cWARNING, set_value, "Object type for '" & obj_name & "' was not recognized"
		set_value = cFAIL
	End Select
End Function

'set_value "txtConfirmationWAM", "aaa"

'select_tab "tabDealDetails","Confirmation"
'get_object_by_name "txtConfirmationWAM",control,win

'GenerateObjectRepositoryList Null
EnumarateAllChildrenProperties Null, ""


'Call RenameAllImages(null)
'Call RemoveAllLinks(null)

'Set ImageObj = RepositoryFrom.GetObject("Browser(""CNN.com"").Page(""CNN.com"").Image(""Remains identified"")")
'If (not IsNull(ImageObj)) Then
' MsgBox RepositoryFrom.GetLogicalName(ImageObj)
' Else MsgBox "null"
'End If
'Set PageObj = RepositoryTo. GetObjectByParent ("Browser(""CNN.com"")",   "Page(""CNN.com"")")
'If (not IsNull(PageObj)) Then
' MsgBox RepositoryTo.GetLogicalName(PageObj)
' Else MsgBox "null"
'End If

























